/*
 * greg.h -- global register encoding
 */


#ifndef _GREG_H_
#define _GREG_H_


#include "common.h"


#define rA	21
#define rB	0
#define rC	8
#define rD	1
#define rE	2
#define rF	22
#define rG	19
#define rH	3
#define rI	12
#define rJ	4
#define rK	15
#define rL	20
#define rM	5
#define rN	9
#define rO	10
#define rP	23
#define rQ	16
#define rR	6
#define rS	11
#define rT	13
#define rU	17
#define rV	18
#define rW	24
#define rX	25
#define rY	26
#define rZ	27
#define rBB	7
#define rTT	14
#define rWW	28
#define rXX	29
#define rYY	30
#define rZZ	31


typedef struct {
  char *name;
  int code;
  char *description;
} Greg;


extern Greg gregTbl[];
extern Greg *gregCodeTbl[];


void initGregTable(void);
Greg *lookupGreg(char *name);


#endif /* _GREG_H_ */
