%
% rom05.mms - more realistic subroutine call & return
%

	LOC	#8000FFFF00000000

Main	JMP	Start

%	$0	digit to output, gets converted to ASCII
%	$1	base address of terminal registers
%		+16 is transmitter status
%		+24 is transmitter data
%	$2	auxiliary data

OutPB	SETH	$1,#8001	% set terminal base address
	ADDU	$0,$0,#0030	% convert digit to ASCII
2H	LDOU	$2,$1,16	% put status word into $2
	AND	$2,$2,#1	% extract LSB
	PBZ	$2,2B		% loop while transmitter not ready
	STOU	$0,$1,24	% write character to terminal
	SUBU	$0,$0,#0030	% convert back to digit
	POP	2,0		% return

Start	SETH	$1,#ABCD	% waste a register
	ORL	$1,#EF
	SETH	$2,#0000	% set digit to display
	ORL	$2,#0001
1H	PUSHJ	$1,OutPB	% fadeout registers $0 and $1, pass $2 as $0
	ADDU	$2,$2,1		% increment digit
	CMP	$1,$2,10	% we only handle a single digit
	PBNZ	$1,1B		% ok - go on
	JMP	Start		% else start all over again
