%
% rom07.mms
%
% Demonstration of a subroutine call to print out a complete
% line, and returning the number of printed characters.
%

	LOC	#8000FFFF00000000

Main	JMP	Start

%	$0	digit to output, gets converted to ASCII
%	$1	base address of terminal registers
%		+16 is transmitter status
%		+24 is transmitter data
%	$2	auxiliary data

pBuf	IS	$0
TBase	IS	$1
Tmp	IS	$2
Count	IS	$3
Char	IS	$4

PrintS	SETH	TBase,#8001		% set terminal base address
	SETH	Count,#0		% also clears the other 48 bits

3H	LDBU	Char,pBuf,Count		% load a character
	BZ	Char,2F			% string is terminated by #0

1H	LDOU	Tmp,TBase,16		% put status word into Tmp
	AND	Tmp,Tmp,#1		% extract LSB
	PBZ	Tmp,1B			% loop while transmitter not ready

	STOU	Char,TBase,24		% write character to terminal

	ADDU	Count,Count,1 		% and count the character
	JMP	3B			% next character

2H	ADDU	$0,Count,0		% copy character count to $0
	POP	1,0			% and return it


%	Print the hexadecimal number in register $0.
%
%	$3	pointer to static digit buffer
%	$1	current digit (remainder from last division)
%	$2	tmp

PrintH	SETL	$3,#1000		% get buffer pointer
	ADD	$3,$3,20		% move to end of buffer
	SETL	$2,0			% 0
	STBU	$2,$3
	SUBU	$3,$3,1
	SETL	$2,#a			% lf
	STBU	$2,$3
	SUBU	$3,$3,1
	SETL	$2,#d			% cr
	STBU	$2,$3
	SUBU	$3,$3,1

1H	DIV	$0,$0,16		% extract least digit into rR
	GET	$1,6			% get digit from rR into $1

	CMP	$2,$1,9			% check if 0..9
	PBNP	$2,2F			% yes - jump
	ADDU	$1,$1,'a'-10		% else convert to 'a'..'f'
	JMP	3F
2H	ADDU	$1,$1,'0'		% convert 0..9 to '0'..'9'
3H	STBU	$1,$3			% store at current buffer pos
	SUBU	$3,$3,1			% move pointer one digit higher
	PBNZ	$0,1B			% if not finished continue

	ADD	$3,$3,1			% move pointer to last used digit
	GET	$1,rJ			% restore "return jump" register
  	PUSHJ	$2,PrintS		% print the hexadecimal number
        PUT	rJ,$1			% restore "return jump" register
	POP	0,0			% return nothing


%	Main program

Start	SETH	$1,#abcd	% waste a register
	ORL	$1,#ef
	GETA	$2,Text		% set Textpointer
1H	PUSHJ	$1,PrintS	% fadeout registers $0 and $1, and call PrintS,
				% pass $2 as $0, $1 catches the result
	PUSHJ	$0,PrintH	% Print out result from PrintS
Stop	JMP	Stop

Text	BYTE	"This is a very short text.",#0d,#0a,0,0,0,0
