
% Demonstrates the start of a 'process' from OS
% through a 'RESUME'-Call.
% The 'process' increments
% register $253 (which is global (put rG...)),
% and TRAPs back into the OS,
% the OS prints the content of $253 and resumes
% to the 'process'.


% physical location of virt. address #0000000000000100
% in Alpha configuration

	LOC	#0000abcdabcde100

1H 	ADDU	$253,$253,1
	TRAP	1,2,3
	JMP	1B


% location where processor looks up PTE for virt. address

	LOC	#0000000000200000

PTE	OCTA	#0000abcdabcde007




% OS code

	LOC	#0000ffff00000000
Main	JMP	Start

#include "pregs.mmi"

% TrapHandler for software traps

Wrt253	ADDU	$1,$253,0
	PUSHJ	$0,utils:PrintH
	PUSHJ	$0,utils:PrintLF
	SETMH	$255,#00ff

	RESUME	1

% setup (bootstrap)

Start	PUSHJ	$0,utils:Init

	SETL	$0,250		% set global threshold
	PUT	rG,$0

        GETA    $0,Wrt253       % Set Trap Handler adress
	PUT     rT,$0

        SETH    $1,#3210
	ORMH    $1,#0D00
	ORML    $1,#0020        % Set rootlocation to #0100
	ORL     $1,#0000        % config for rV (Aplha21064)
	PUT     rV,$1
					
	SETL	$0,#0100	% Set Address of 'user-process'
	PUT	rWW,$0

	SETH	$0,#8000
	PUT	rXX,$0		% do not insert any instruction
				% into execution stream

	SETMH   $255,#00ff	% new mask in rK after resume

	RESUME	1

Ende    JMP     Ende

